﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace KairoEngine.Core
{
    public class ObjectChangePositionCommand : ICommand
    {
        GameObject obj;
        Vector3 position;
        Quaternion rotation;

        public ObjectChangePositionCommand(GameObject obj, Vector3 position, Quaternion rotation)
        {
            this.obj = obj;
            this.position = position;
            this.rotation = rotation;
        }

        public void Execute()
        {
            obj.transform.position = position;
            obj.transform.rotation = rotation;
        }
    }
}