﻿using System.Collections;
using System.Linq;
using System.Collections.Generic;
using UnityEngine;
using Sirenix.OdinInspector;
using KairoEngine.Core;

namespace KairoEngine.Core.GameActions
{

    [System.Serializable, HideReferenceObjectPicker]
    public class OnTriggerEnterGameActionTrigger : GameActionTriggerBase
    {
        public override string name 
        { 
            get
            {
                return $"On Trigger Enter";
            }
        }

        public override GameActionTriggersController controller { 
            get => _controller; 
            set 
            {
                _controller = value;
                typeName = "OnTriggerEnterGameActionTrigger";
            }
        }
        public override string GetTypeName() => "OnTriggerEnterGameActionTrigger";
        public override string GetTriggerName() => "On Trigger Enter";

        [IconFoldoutGroup("@name", "Assets/Plugins/KairoEngine/Core/Editor/Icons/OnTriggerEnterGameActionTriggerIcon.png")] 
        public string message = "Debug Log Message";

        public override void OnEnable() { }

        public override void Update() { }

        public override void OnDisable() { }

        public static OnTriggerEnterGameActionTrigger JSONToOnTriggerEnterGameActionTrigger(string data)
        {
            return JsonUtility.FromJson<OnTriggerEnterGameActionTrigger>(data);
        }

        private OnTriggerEnterGameActionTrigger Duplicate()
        {
            OnTriggerEnterGameActionTrigger trigger = new OnTriggerEnterGameActionTrigger();
            trigger.controller = controller;
            return trigger;
        }

    }
}

